(function(global) {
    "use strict";

    global.FRCC = global.FRCC || {};
    global.FRCC.Portal = global.FRCC.Portal || {};
    global.FRCC.Portal.Documents = (function() {

        $(function(ready) {
            $(".document-upload").change(function() {
                uploadFiles($(this).data('folder'), $(this)[0].files, $(this).data('documentvalidation'));
                $(this)[0].value = null; //clear the file so if the same file is selected again the change event is triggered.
            });
        });

        var setUpForDocUpload = function() {
            /*$(".document-upload").change(function(){
                      uploadFiles($(this).data('folder'), $(this)[0].files, $(this).data('documentvalidation'));
                  });*/
        };

        var _xmlToJson = function(xml) {
            var obj = {};

            // console.log(xml.nodeType, xml.nodeName );

            if (xml.nodeType == 1) { // element
                // do attributes
                if (xml.attributes.length > 0) {
                    obj["@attributes"] = {};
                    for (var j = 0; j < xml.attributes.length; j++) {
                        var attribute = xml.attributes.item(j);
                        obj["@attributes"][attribute.nodeName] = attribute.nodeValue;
                    }
                }
            } else if (xml.nodeType == 3 ||
                xml.nodeType == 4) { // text and cdata section
                obj = xml.nodeValue
            }

            // do children
            if (xml.hasChildNodes()) {
                for (var i = 0; i < xml.childNodes.length; i++) {
                    var item = xml.childNodes.item(i);
                    var nodeName = item.nodeName;
                    if (typeof(obj[nodeName]) == "undefined") {
                        obj[nodeName] = _xmlToJson(item);
                    } else {
                        if (typeof(obj[nodeName].length) == "undefined") {
                            var old = obj[nodeName];
                            obj[nodeName] = [];
                            obj[nodeName].push(old);
                        }
                        if (typeof(obj[nodeName]) === 'object') {
                            obj[nodeName].push(_xmlToJson(item));
                        }
                    }
                }
            }
            return obj;
        };

        var uploadFiles = async(folderName, fileArr, documentValidation) => {
            try {
                var folderNum = folderName.replace(/\D/g, "");
                var imageName = ".document-" + folderNum + "-image";

                $(imageName).show();

                var url = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_AzureBlobURL");
                if (url.endsWith("/")) { //remove final '/' from URL if there is one
                    url = url.substring(0, url.length - 1)
                }
                const azureBlobUrl = url;
                const accountName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobaccountname");
                const sasString = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_ContainerSASToken");;
                const containerName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobcontainername");
                const containerURL = new azblob.ContainerURL(
                    `${azureBlobUrl}/${containerName}?${sasString}`,
                    azblob.StorageURL.newPipeline(new azblob.AnonymousCredential));

                console.log("Uploading files....");
                const promises = [];
                for (const file of fileArr) {
                    //IF HEIC file type convert first to jpeg
                    var fileName = file.name.split(".")[0];
                    /*var duplicateFileDetected = checkFileDupe(fileName, folderName);
                    if(duplicateFileDetected == true) {
                      $("#duplicateFileBtn").first().click();
                      window.duplicatedFileTemp = file;
                      window.duplicatedFileFolderTemp = folderName;
                      $(imageName).hide();
                      return;
                    }*/
                    /*if(fileName == "heic" || fileName == "heif") {
                      var convertedFile = await heic2any({
                        blob: file,
                        toType: "image/jpeg",
                        quality: 0.5
                      }).then(result => {
                        return result;
                      })
                    }
                    if (convertedFile) {
                      convertedFile.name = file.name.split(".")[0] + ".jpeg";
                      convertedFile.type = "image/jpeg"
                      console.log(convertedFile);
                      file = convertedFile;
                    }*/
                    var baseUrl = containerURL.url.split('?')[0];
                    var sasToken = containerURL.url.split('?')[1];
                    var tagId = $("#hdn-applicationnumber").val();
                    var newBlobPath = $("#hdn-applicationblobpath").val();
                    var applicationNumber = $("#hdn-applicationnumber").val();
                    var blobPath = '';
                    var blobPathBuilder = '';
                    var blobPath = baseUrl + "/" + newBlobPath + "/" + folderName + "/" + file.name + "?" + sasToken;
                    blobPathBuilder = newBlobPath;

                    window.fileName = file.name;
                    validateFileExtensionsAndSize(file);
                    console.log("after validateFileExtensionsAndSize");
                    
                    var options = {};
                    var fileExtension = file.name.split(".")[1].toLowerCase();
                    if (fileExtension === "pdf") {
                        options = {
                            blobHTTPHeaders: {
                                blobContentType: "application/pdf"
                            }
                        }
                    }

                    if (window.documentExtensionsOrSizeValid == true) {
                        const blockBlobURL = azblob.BlockBlobURL.fromContainerURL(containerURL, blobPathBuilder + `/${folderName}/` + file.name);
                        if (documentValidation == "203300001") {
                            for (const file of Object.values(window.nameArray)) {
                                if (folderName in file) {
                                    var delFileName = file[folderName];
                                    var delFolderName = folderName;
                                    var deleteFileUrl = baseUrl + "/" + newBlobPath + "/" + delFolderName + "/" + delFileName + "?" + sasToken;
                                    promises.push(deleteFile(deleteFileUrl));
                                }
                            }
                        }
                        promises.push(azblob.uploadBrowserDataToBlockBlob(
                            azblob.Aborter.none, file, blockBlobURL, options));
                    }
                }
                window.folderName = folderName;
                if (window.documentExtensionsOrSizeValid == true) {
                    setTimeout(function() {
                        tagFile(blobPath, tagId, folderName, imageName, newBlobPath);
                    }, 1000);
                }
            } catch (error) {
                console.log(error);
            }
        };

        var attachedFilesValidation = function() {
            $("input[data-documentvalidation='203300001']").each(function(index) {
                if ($(this) && $(this).val() != null) {
                    $(this).attr("title", "You can only submit one document. Any new document will replace the existing one.");
                    $(this).attr("data-toggle", "tooltip");
                }

                var order = $(this).attr("data-documentorder");
                var documentInputNumber = $(this).attr("id").split("-")[1];
                var folderName = $(`input#document-${documentInputNumber}`).data('folder');

                if (typeof(Page_Validators) == 'undefined') return;
                var attachedFilesValidator = document.createElement('span');
                attachedFilesValidator.style.display = "none";
                attachedFilesValidator.id = "attachedFilesValidator";
                attachedFilesValidator.controltovalidate = "";
                attachedFilesValidator.errormessage = `<a href='#${order}'>You must attach one required document for this category: ${folderName}</a>`;
                attachedFilesValidator.validationGroup = `validation-${order}`;
                attachedFilesValidator.initialvalue = "";
                attachedFilesValidator.evaluationfunction = function() {
                    for (const file of Object.values(window.nameArray)) {
                        if (folderName in file) {
                            return true;
                        }
                    }
                    return false;
                };
                Page_Validators.push(attachedFilesValidator);

                var attachedFilesValidatorSubmitFinal = document.createElement('span');
                attachedFilesValidatorSubmitFinal.style.display = "none";
                attachedFilesValidatorSubmitFinal.id = "attachedFilesValidatorSubmitFinal";
                attachedFilesValidatorSubmitFinal.controltovalidate = "";
                attachedFilesValidatorSubmitFinal.errormessage = `<a href='#${order}'>You must attach one required document for this category: ${folderName}</a>`;
                attachedFilesValidatorSubmitFinal.validationGroup = `validation-${$(".submit-btn").length + 1}`;
                attachedFilesValidatorSubmitFinal.initialvalue = "";
                attachedFilesValidatorSubmitFinal.evaluationfunction = function() {
                    for (const file of Object.values(window.nameArray)) {
                        if (folderName in file) {
                            return true;
                        }
                    }
                    if (!order) {
                        return true;
                    }
                    return false;
                };
                Page_Validators.push(attachedFilesValidatorSubmitFinal);

            });


            $("input[data-documentvalidation='203300002']").each(function(index) {
                var order = $(this).attr("data-documentorder");
                var documentInputNumber = $(this).attr("id").split("-")[1];
                var folderName = $(`input#document-${documentInputNumber}`).data('folder');
                if (typeof(Page_Validators) == 'undefined') return;
                var attachedFilesValidator = document.createElement('span');
                attachedFilesValidator.style.display = "none";
                attachedFilesValidator.id = "attachedFilesValidator";
                attachedFilesValidator.controltovalidate = "";
                attachedFilesValidator.errormessage = `<a href='#${order}'>You must attach one or more required documents for this category: ${folderName}</a>`;
                attachedFilesValidator.validationGroup = `validation-${order}`;
                attachedFilesValidator.initialvalue = "";
                attachedFilesValidator.evaluationfunction = function() {
                    for (const file of Object.values(window.nameArray)) {
                        if (folderName in file) {
                            return true;
                        }
                    }
                    return false;
                };
                Page_Validators.push(attachedFilesValidator);

                var attachedFilesValidatorSubmitFinal = document.createElement('span');
                attachedFilesValidatorSubmitFinal.style.display = "none";
                attachedFilesValidatorSubmitFinal.id = "attachedFilesValidatorSubmitFinal";
                attachedFilesValidatorSubmitFinal.controltovalidate = "";
                attachedFilesValidatorSubmitFinal.errormessage = `<a href='#${order}'>You must attach one required document for this category: ${folderName}</a>`;
                attachedFilesValidatorSubmitFinal.validationGroup = `validation-${$(".submit-btn").length + 1}`;
                attachedFilesValidatorSubmitFinal.initialvalue = "";
                attachedFilesValidatorSubmitFinal.evaluationfunction = function() {
                    for (const file of Object.values(window.nameArray)) {
                        if (folderName in file) {
                            return true;
                        }
                    }
                    if (!order) {
                        return true;
                    }
                    return false;
                };
                Page_Validators.push(attachedFilesValidatorSubmitFinal);

            });

        };

        var tagFile = function(blobPath, tagId, folderName, imageName, childApplicationName) {
            var payload = `
              <Tags>  
                <TagSet>  
                    <Tag>  
                        <Key>Id</Key>  
                        <Value>${tagId}</Value>  
                    </Tag>
                    <Tag>  
                        <Key>Folder</Key>  
                        <Value>${folderName}</Value>  
                    </Tag> 
                    <Tag>  
                       <Key>Deleted</Key>  
                       <Value>No</Value>  
                    </Tag>
                    <Tag>  
                       <Key>EDMSync</Key>  
                       <Value>No</Value>  
                    </Tag> 
                </TagSet>  
              </Tags>`;

            if (blobPath.indexOf("?")) {
                blobPath = blobPath.split("?")[0];
                console.log(blobPath);
            }
            var containerToken = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_ContainerSASToken");

            $.ajax({
                type: "PUT",
                url: `${blobPath}${containerToken}&comp=tags`,
                //headers: {type:'blob'},
                data: payload,
                success: function(response) {
                    setTimeout(function() {
                        //convertDocumentToPDF($("#hdn-applicationnumber").val(), window.folderName, window.fileName, blobPath, childApplicationName);
                        listErrorFilesById($("#hdn-applicationnumber").val(), imageName);
                        setTimeout(function() {
                            listErrorFilesById($("#hdn-applicationnumber").val(), imageName);
                        }, 3000);
                    }, 1000);
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    setTimeout(function() {
                        console.log(errorThrown);
                        tagFile(blobPath, $("#hdn-applicationnumber").val(), window.folderName, imageName);
                    }, 1000);
                }
            });
        };


        var deleteFile = function(fileUrl) {
            $.ajax({
                type: "DELETE",
                url: `${fileUrl}`,
                headers: {
                    'Access-Control-Allow-Origin': '*',
                },
                success: function(response) {
                    setTimeout(function() {
                        listErrorFilesById($("#hdn-applicationnumber").val());
                    }, 500);
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    console.log(textStatus);
                }
            });
        };
        var listErrorFilesById = function(recordId, imageName) {
            var url = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_AzureBlobURL");
            if (url.endsWith("/")) { //remove final '/' from URL if there is one
                url = url.substring(0, url.length - 1)
            }
            const azureBlobUrl = url;
            var containerName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobcontainername");
            var accountName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobaccountname");
            var accountToken = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_AccountSASToken");

            $.ajax({
                type: "GET",
                url: `${azureBlobUrl}${accountToken}&comp=blobs&where=@container${encodeURIComponent("='" + containerName + "'")} and Id${encodeURIComponent('=' + "'" + recordId + "'")} and ErrorMessage${encodeURIComponent("='Error from Power Automate'")}`,
                success: function(response) {
                    var testObj = response.documentElement;
                    var xmlObj = new window.DOMParser().parseFromString(testObj.innerHTML.split('<NextMarker/>')[0].split('</Where>')[1], "text/xml");
                    var jsonResponse = _xmlToJson(xmlObj);
                    listFilesById(recordId, jsonResponse, imageName);
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    alert("error");
                }
            });
        };

        var listFilesById = function(recordId, errorDocs, imageName) {
            window.errorDocs = errorDocs;
            var url = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_AzureBlobURL");
            if (url.endsWith("/")) { //remove final '/' from URL if there is one
                url = url.substring(0, url.length - 1)
            }
            const azureBlobUrl = url;
            var containerName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobcontainername");
            var accountName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobaccountname");
            var accountToken = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_AccountSASToken");

            $.ajax({
                type: "GET",
                //TODO: this needs to be either retrieved from configuration or published out via Application Type publishing
                url: `${azureBlobUrl}${accountToken}&comp=blobs&where=@container${encodeURIComponent("='" + containerName + "'")} and Id${encodeURIComponent('=' + "'" + recordId)}'`,
                success: function(response) {
                    $(imageName).hide();
                    $("#document-1-status").hide();
                    $("#document-2-status").hide();
                    $("#document-3-status").hide();
                    var testObj = response.documentElement;
                    var xmlObj = new window.DOMParser().parseFromString(testObj.innerHTML.split('<NextMarker/>')[0].split('</Where>')[1], "text/xml");
                    var jsonResponse = _xmlToJson(xmlObj);
                    $("#documents").find("tr:gt(0)").remove();
                    window.nameArray = {};
                    if (jsonResponse.Blobs.Blob && !Array.isArray(jsonResponse.Blobs.Blob)) {
                        $(".document-upload").each(function(i) {
                            var folder = $(this).data('folder');
                            var name = jsonResponse.Blobs.Blob.Name["#text"].split($("#hdn-applicationblobpath").val() + "/" + folder + "/")[1];
                            if (name) {
                                $('#documents tr:last').after(`<tr data-row="0"><th onclick="FRCC.Portal.Documents.downloadAttachment('${name}', '${folder}')" class="document-upload">${name}</th><th>${folder}</th><th><span class="btn btn-primary button" onclick="FRCC.Portal.Documents.setDeleteTag('${name}', '${folder}', 0)">Delete</span></th></tr>`);
                                //
                                $('#' + $(this).attr('id') + '-status').show();
                                window.nameArray[0] = ({
                                    [folder]: name
                                });
                            }
                        });
                    } else if (jsonResponse.Blobs.Blob && Array.isArray(jsonResponse.Blobs.Blob)) {
                        var index = 0;
                        for (const file of jsonResponse.Blobs.Blob) {
                            $(".document-upload").each(function(i) {
                                var folder = $(this).data('folder');

                                var name = file.Name["#text"].split($("#hdn-applicationblobpath").val() + "/" + folder + "/")[1];

                                var hasError = global.FRCC.Portal.Utilities.searchForError(file.Name["#text"], window.errorDocs.Blobs);
                                var errorIcon = "";
                                if (hasError) {
                                    var errorIcon = `<span class="glyphicon glyphicon-alert alert-icon" aria-hidden="true" title="Error from Power Automate" ></span>`;
                                }
                                if (name) {
                                    $('#documents tr:last').after(`<tr><th onclick="FRCC.Portal.Documents.downloadAttachment('${name}', '${folder}')" class="document-upload">${name}</th><th>${folder}</th><th><span class="btn btn-primary button" onclick="FRCC.Portal.Documents.setDeleteTag('${name}', '${folder}', 0)">Delete</span></th></tr>`);
                                    $('#' + $(this).attr('id') + '-status').show();
                                    window.nameArray[index] = ({
                                        [folder]: name
                                    });
                                    index++;
                                }
                            });
                        }
                    }

                    $(imageName).hide();

                    return;
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    alert("error");
                }
            });
        };

        var convertDocumentToPDF = function(tagId, folderName, fileName, blobPath, childApplicationName) {
            var convertToPdfUrl = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_ConverttoPDFURL");

            var payload = {
                "fileName": fileName,
                "recordFolder": childApplicationName,
                "fileFolder": folderName,
                "recordId": tagId,
                "fullFileUrl": blobPath
            };

            $.ajax({
                type: "POST",
                url: convertToPdfUrl,
                headers: { "Content-Type": "application/json" },
                data: JSON.stringify(payload),
                success: function(response) {
                    setTimeout(function() { listErrorFilesById(tagId); }, 1000);
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {}
            });
        }

        var validateFileExtensionsAndSize = function(file) {

            var fileExtension = file.name.split(".")[1];
            let fileExtensionType = file.name.split(/\.(?=[^\.]+$)/);

            var validExtensions = ['image/bmp', 'application/msword', 'application/pdf', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'image/gif', 'image/jpeg', 'image/png', 'application/vnd.ms-powerpoint',
                'application/vnd.openxmlformats-officedocument.presentationml.presentation', 'image/tiff', 'application/vnd.ms-excel', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
            ];
            window.documentExtensionsOrSizeValid = true;

            if (fileExtensionType[1] === "xml" || fileExtensionType[1] === "webp") {
                window.documentExtensionsOrSizeValid = false;
                alert("ERROR: You are attempting to upload an invalid document type.");
            }
            
            if (!validExtensions.includes(file.type)) {
                console.log(file.type);
                //sometimes heic files have empty file types and should not go into this alert
                if (fileExtension == "heic" || fileExtension == "heif") {
                    window.documentExtensionsOrSizeValid = false;
                    alert("ERROR: You are attempting to upload an invalid document type.");
                }
            } else if (file.size / 1000000 > 15 && fileExtensionType[1] === "pdf") {
                window.documentExtensionsOrSizeValid = false;
                alert("Error: PDF document size cannot exceed 15mb.");
            }
            //throw error if file size is greater than 100mb
            else if (file.size / 1000000 > 100) {
                window.documentExtensionsOrSizeValid = false;
                alert("ERROR: You are attempting to upload a file larger than 100mb");
            }
        }


        var downloadAttachment = function(fileName, folderName) {
            var url = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_AzureBlobURL");
            if (url.endsWith("/")) { //remove final '/' from URL if there is one
                url = url.substring(0, url.length - 1)
            }
            const azureBlobUrl = url;
            var containerName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobcontainername");
            var accountName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobaccountname");
            var containerToken = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_ContainerSASToken");
            var blobPath = $("#hdn-applicationblobpath").val();
            var link = document.createElement("a");
            link.download = fileName;
            link.href = `${azureBlobUrl}/${containerName}/${blobPath}/${encodeURIComponent(folderName)}/${encodeURIComponent(fileName)}${containerToken}`;
            link.click();
        };

        var setDeleteTag = function(fileName, folderName, row) {
            var url = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_AzureBlobURL");
            if (url.endsWith("/")) { //remove final '/' from URL if there is one
                url = url.substring(0, url.length - 1)
            }
            const azureBlobUrl = url;
            var containerToken = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_ContainerSASToken");
            const accountName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobaccountname");
            const sasString = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_ContainerSASToken");;
            const containerName = global.FRCC.Portal.Utilities.getEnvironmentVariable("eyfrcc_blobcontainername");
            const containerURL = new azblob.ContainerURL(
                `${azureBlobUrl}/${containerName}?${sasString}`,
                azblob.StorageURL.newPipeline(new azblob.AnonymousCredential));
            var baseUrl = containerURL.url.split('?')[0];
            var sasToken = containerURL.url.split('?')[1];
            var tagId = $("#hdn-applicationnumber").val();
            var newBlobPath = $("#hdn-applicationblobpath").val();
            var applicationNumber = $("#hdn-applicationnumber").val();
            var blobPath = '';
            var blobPathBuilder = '';
            var blobPath = baseUrl + "/" + newBlobPath + "/" + folderName + "/" + fileName + "?" + sasToken;



            //azureblobgurl/container/filepath?containerSas&comp=tags


            if (!confirm("Are you sure you want to delete this file?")) {
                return;
            }
            $('tr[data-row="' + row + '"]').hide();
            //Check current tags to see if the EDMID has already been set.
            //If so, add that back into the tags and set EDMSync = Yes
            $.ajax({
                type: "GET",
                url: `${blobPath}${containerToken}&comp=tags`,
                success: function(response) {
                    var json = _xmlToJson(response.documentElement);
                    var edmid = "";
                    for (var tagNum = 0; tagNum < json.TagSet.Tag.length; tagNum++) {
                        if (json.TagSet.Tag[tagNum].Key["#text"] == "EDMID") { //Find EDMID Tag, get value of tag.
                            edmid = json.TagSet.Tag[tagNum].Value["#text"];
                            break;
                        }
                    }
                    var payload = "";
                    if (edmid == "") {
                        payload = `
                        <Tags>  
                          <TagSet> 
                          <Tag>  
                                  <Key>Id</Key>  
                                  <Value>${tagId}-Deleted</Value>  
                              </Tag>
                              <Tag>  
                                  <Key>Folder</Key>  
                                  <Value>${folderName}</Value>  
                              </Tag>   
                              <Tag>  
                                  <Key>Deleted</Key>  
                                  <Value>Yes</Value>  
                              </Tag>
                              <Tag>  
                                  <Key>EDMSync</Key>  
                                  <Value>No</Value>  
                              </Tag>
                          </TagSet>  
                        </Tags>`;
                    } else {
                        payload = `
                        <Tags>  
                          <TagSet> 
                          <Tag>  
                                  <Key>Id</Key>  
                                  <Value>${tagId}-Deleted</Value>  
                              </Tag>
                              <Tag>  
                                  <Key>Folder</Key>  
                                  <Value>${folderName}</Value>  
                              </Tag>   
                              <Tag>  
                                  <Key>Deleted</Key>  
                                  <Value>Yes</Value>  
                              </Tag>
                              <Tag>  
                                  <Key>EDMSync</Key>  
                                  <Value>Yes</Value>  
                              </Tag>
                              <Tag>  
                                  <Key>EDMID</Key>  
                                  <Value>${edmid}</Value>  
                              </Tag>
                          </TagSet>  
                        </Tags>`;
                    }
                    //Update tags
                    $.ajax({
                        type: "PUT",
                        url: `${blobPath}${containerToken}&comp=tags`,
                        //headers: {type:'blob'},
                        data: payload,
                        success: function(response) {
                            setTimeout(function() {
                                listErrorFilesById($("#hdn-applicationnumber").val(), "");
                                setTimeout(function() {
                                    listErrorFilesById($("#hdn-applicationnumber").val(), "");
                                }, 3000);
                            }, 2000);
                        },
                        error: function(XMLHttpRequest, textStatus, errorThrown) {
                            setTimeout(function() {
                                console.log(errorThrown);
                                tagFile(blobPath, $("#hdn-applicationnumber").val(), window.folderName, "");
                            }, 1000);
                        }
                    });
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    alert(errorThrown);
                }
            });
        }

        return {
            setUpForDocUpload: setUpForDocUpload,
            listErrorFilesById: listErrorFilesById,
            downloadAttachment: downloadAttachment,
            attachedFilesValidation: attachedFilesValidation,
            setDeleteTag: setDeleteTag
        }
    })();

})(this);



$(document).ready(function() {






});